
//OSCFunc.trace;//identificar os endereços dos controles no mrmr

(
//tamanho da resolução da projeção EX.: 1080p = 1920x1080, MBA11" = 1366x768
~width = 1366;
~height = 768;

//contorle das cores
a = OSCdef(\redfad, { |m| (~red=m[1].linlin(0,1,0,255).value.poll)},'/mrmr/slider/horizontal/0/iPad-de-Nikolas-Gomes-Ferrand');
b = OSCdef(\grefad, { |m| (~green=m[1].linlin(0,1,0,255).value.poll)},'/mrmr/slider/horizontal/1/iPad-de-Nikolas-Gomes-Ferrand');
c = OSCdef(\blufad, { |m| (~blue=m[1].linlin(0,1,0,255).value.poll)},'/mrmr/slider/horizontal/2/iPad-de-Nikolas-Gomes-Ferrand');
d = OSCdef(\alpfad, { |m| (~alpha=m[1].linlin(0,1,0,255).value.poll)},'/mrmr/slider/horizontal/3/iPad-de-Nikolas-Gomes-Ferrand');

//controle do spot A
e = OSCdef(\radfad, { |m| (~radius=m[1].linlin(0,1,-50,1500).value.poll)},'/mrmr/tactile3DZ/15/iPad-de-Nikolas-Gomes-Ferrand');
f = OSCdef(\xfad, { |m| (~xspot=m[1].linlin(0,1,-1/2*~width,~width/2).value.poll)},'/mrmr/tactile3DY/15/iPad-de-Nikolas-Gomes-Ferrand');
g = OSCdef(\yfad, { |m| (~yspot=m[1].linlin(0,1,~height/2,-1/2*~height).value.poll)},'/mrmr/tactile3DX/15/iPad-de-Nikolas-Gomes-Ferrand');
h = OSCdef(\gat, { |m| (~gat=m[1].linlin(0,1,0,1).value.poll)},'/mrmr/tactilezoneTouchDown/15/iPad-de-Nikolas-Gomes-Ferrand');
i = OSCdef(\gat2, { |m| (~gat2=m[1].linlin(0,1,0,1).value.poll)},'/mrmr/pushbutton/8/iPad-de-Nikolas-Gomes-Ferrand');
~excx = OSCdef(\excX, { |m| (~excX=m[1].linlin(0,1,1,10).value.poll)},'/mrmr/slider/horizontal/10/iPad-de-Nikolas-Gomes-Ferrand');
~excy = OSCdef(\excY, { |m| (~excY=m[1].linlin(0,1,1,10).value.poll)},'/mrmr/slider/horizontal/9/iPad-de-Nikolas-Gomes-Ferrand');

//controle do spot B
j = OSCdef(\radfadb, { |m| (~radiusB=m[1].linlin(0,1,-50,1500).value.poll)},'/mrmr/tactile3DZ/5/iPad-de-Nikolas-Gomes-Ferrand');
k = OSCdef(\xfadb, { |m| (~xspotB=m[1].linlin(0,1,-1/2*~width,~width/2).value.poll)},'/mrmr/tactile3DY/5/iPad-de-Nikolas-Gomes-Ferrand');
l = OSCdef(\yfadb, { |m| (~yspotB=m[1].linlin(0,1,~height/2,-1/2*~height).value.poll)},'/mrmr/tactile3DX/5/iPad-de-Nikolas-Gomes-Ferrand');
m = OSCdef(\gatb, { |m| (~gatB=m[1].linlin(0,1,0,1).value.poll)},'/mrmr/tactilezoneTouchDown/5/iPad-de-Nikolas-Gomes-Ferrand');
n = OSCdef(\gat2b, { |m| (~gat2B=m[1].linlin(0,1,0,1).value.poll)},'/mrmr/pushbutton/14/iPad-de-Nikolas-Gomes-Ferrand');
~excxB = OSCdef(\excX, { |m| (~excXB=m[1].linlin(0,1,1,10).value.poll)},'/mrmr/slider/horizontal/11/iPad-de-Nikolas-Gomes-Ferrand');
~excyB = OSCdef(\excY, { |m| (~excYB=m[1].linlin(0,1,1,10).value.poll)},'/mrmr/slider/horizontal/12/iPad-de-Nikolas-Gomes-Ferrand');

//controle do flash
o = OSCdef(\gatfl, { |m| (~gatFl=m[1].linlin(0,1,0,1).value.poll)},'/mrmr/pushbutton/13/iPad-de-Nikolas-Gomes-Ferrand');

s.options.memSize = 128 * 1024;
s.latency= 0.05;
s.waitForBoot{

	//--window setup
	var width= ~width, height= ~height;
	var j= Window("cores", Rect(99, 99, width, height), true);
	var u= UserView(j, Rect(0, 0, width, height));
	~fps= 48; //framerate da animação

	//--cor
	~red = 255;
	~green = 255;
	~blue = 255;
	~alpha = 255;

	//spot A
	~radius= 10;
	~excX = 1;
	~excY = 1;
	~xspot = -100;
	~yspot = 0;
	~gat = 0;
	~gat2 = 0;

	//spot B
	~radiusB= 10;
	~excXB = 1;
	~excYB = 1;
	~xspotB = 100;
	~yspotB = 0;
	~gatB = 0;
	~gat2B = 0;

	//flash screen
	~gatFl = 0;

	//--main loop
	u.drawFunc= {
		if(u.frame%(~fps/60).reciprocal==0, {
		});
		Pen.translate(width*0.5, height*0.5);                              //offset drawing to the centre
		~gat3 = ~gat + ~gat2;
		~gat3B = ~gatB + ~gat2B;
		if(~gat3 >1, {~gat3 = 1},{~gat3 = ~gat3});
		if(~gat3B >1, {~gat3B = 1},{~gat3B = ~gat3B});
		Pen.fillColor= Color.new255(~red,~green,~blue,~alpha*~gat3);
		Pen.addOval(Rect.aboutPoint(Point(~xspot,~yspot),~radius*~excX,~radius*~excY));
		Pen.fill;
		Pen.fillColor= Color.new255(~red,~green,~blue,~alpha*~gat3B);
		Pen.addOval(Rect.aboutPoint(Point(~xspotB,~yspotB),~radiusB*~excXB,~radiusB*~excYB));
		Pen.fill;
		Pen.fillColor= Color.new255(255,255,255,255*~gatFl);
		Pen.fillRect(Rect.aboutPoint(Point(0, 0), ~width,~height));





	};

	//--window management
	u.clearOnRefresh= true;
	u.background = Color.black(1);
	j.fullScreen;
	//j.front;
	u.animate= true;
	CmdPeriod.doOnce({if(j.isClosed.not, {j.close})});
};
)

